# Using YMLib DLL in Python
## About
This snippet allows the import of a DLL file that was written in VB.NET.

## Prerequisites
This script assumes the following:
- This script has permission to access the folder in which the DLL file is located.
- This script has permission to execute the DLL file.
- You have python installed on your system (note, this was tested with Python 3.11, but is likely to work with most Python3 versions).

## Installation
### Installing the requirements
In the virtual environment of your Python project, run 

```
pip install pythonnet
```

NOTE: Depending on how your python interpreter is setup, you may need to run 
```
python3 -m pip install pythonnet  
```
or
```
py -m pip install pythonnet  
```

### Installing the script in your project
At the top of the file in which you want to use the DLL functions, write:
``` 
import YMLib_DLL
YMLib_DLL.loadYMLibDLL()    
import YMLib  # this is the namespace from the DLL.
```
NOTE:
- The first line imports the script.
- The second line loads the Yamutec YMLib DLL.
- The third line imports the YMLib namespace **from the DLL**, which allows you to use all classes from this DLL.

## Configuration
This script assumes that the DLL is located in a subdirectory of your project, with the following path 
```
project_root>assets>ymlib>Release 
```
and is called: **YMLib.dll**.

If the DLL is located in another directory or has a different name, please change this in the *YMLib_DLL.py*.

## Demo
You can find a demo of how to install and use the DLL in the file *demo.py*. 