# YMLib DLL in Python verwenden
## Inhalt
Dieses Snippet ermöglicht den Import einer DLL-Datei, die in VB.NET geschrieben wurde.

## Voraussetzungen
Dieses Skript setzt Folgendes voraus:
- Dieses Skript hat Leserechte für den Ordner, in dem sich die DLL-Datei befindet.
- Dieses Skript hat Ausführungs-Rechte für die DLL-Datei.
- Python 3 ist installiert (Hinweis: Dieses Skript wurde mit Python 3.11 getestet, aber es funktioniert wahrscheinlich mit den meisten Python3-Versionen).
- Es gibt eine bestehende virtuelle Umgebung (z.B. [venv](https://docs.python.org/3/library/venv.html)) für dieses Python Projekt.

## Installation
### Installation der Voraussetzungen
Installieren Sie pythonnet in diesem Projekt:
```
pip install pythonnet
```

HINWEIS: 
Je nachdem, wie Ihr Python-Interpreter eingerichtet ist, müssen Sie *pip* explizit über Python aufrufen:  
```
python3 -m pip install pythonnet  
```
oder
```
py -m pip install pythonnet  
```

### Installieren Sie das Skript in Ihrem Projekt
Schreiben Sie an den Anfang der Datei, in der Sie die DLL-Funktionen verwenden wollen:
``` 
importiere YMLib_DLL
YMLib_DLL.loadYMLibDLL()    
import YMLib # dies ist der Namespace der DLL, aus dem die Klassen importiert werden.
```
HINWEIS:
- Die erste Zeile importiert das Skript, welches die DLL laden kann.
- Die zweite Zeile lädt die Yamutec YMLib DLL selbst.
- Die dritte Zeile importiert den YMLib-Namespace **aus der DLL**, was Ihnen erlaubt, alle Klassen aus dieser DLL zu verwenden.

## Konfiguration
Dieses Skript geht davon aus, dass sich die DLL in einem Unterverzeichnis Ihres Projektes befindet, mit folgendem Pfad:
```
{{project_root}}>ymlib>Release 
```
und folgendem Namen: **YMLib.dll**.

Wenn sich die DLL in einem anderen Verzeichnis befindet oder einen anderen Namen hat, ändern Sie dies bitte in der *YMLib_DLL.py*.

## Demo
Eine Demo zur Installation und Verwendung der DLL finden Sie in der Datei *demo.py*.