import clr
import sys
import logging

# _assembly_path = r"D:\Entrepreneurship\Projekte\DLL Integration\assets\ymlib\Release"
_assembly_path = r".\ymlib\Release"
_dll_name = "YMLib"  # no need for the .DLL suffix
sys.path.append(_assembly_path)

def loadYMLibDLL():
    try:
        yml_lib = clr.AddReference(_dll_name)  # load the DLL. From now on you can use the namespaces from the DLL.
        print("SUCCESSFULLY LOADED YML Lib!")
        return yml_lib
    except FileNotFoundError:
        logging.error("ctyles.CDLL('{assembly_path}\{dll_name}') could not be opened".format(assembly_path=_assembly_path, dll_name=_dll_name))
        logging.error("DLL not found: please make sure that the path is spelled correctly and that you have permission to access the DLL file.")
    except Exception:
        logging.exception("[ERROR]: Could not load YML Lib! \n Please make sure that:\na) the path is spelled correctly and\nb) that you have permission to execute the DLL file.")