#!/usr/bin/env python

"""
Author: Elias Ladenburger\n
This file is a very simple command line program meant to demonstrate that the YMLib_DLL integration works.
It is NOT intended for productive use.
"""

import YMLib  # mit diesem Import wird die Funktionalität aus der DLL geladen.
import YMLib_DLL

YMLib_DLL.loadYMLibDLL()


def get_ymcom():
    return YMLib.YMTCPData()


def get_ymcom_connection(ip_address: str, port: int, YMCom=None):
    ymcom = YMCom or get_ymcom()
    try:
        # Hier werden die Parameter als String an die DLL weitergegeben.
        ymcom.Connect(ip_address, port)
    except Exception as e:
        print(e)
    finally:
        return ymcom


def send_status_hybrid(ymcom, sendbyte1: str, sendbyte2: str, sendbyte3: str, sendbyte4: str):
    ymcom.SEND_STATUS_HYBRID32(sendbyte1, sendbyte2, sendbyte3, sendbyte4)


def is_open(ymcom):
    return ymcom.IsOpen


if __name__ == "__main__":
    ymcom = get_ymcom()
    ymcom = get_ymcom_connection("192.168.0.11", 2005)
    send_status_hybrid(ymcom, "1", "1", "1", "1")
    is_open(ymcom)
