"""
Author: Elias Ladenburger\n
This file is a very simple UI meant to demonstrate that the YMLib_DLL integration works.
It is NOT intended for productive use.
"""

# importing UI libraries
import tkinter as tk
from tkinter import messagebox, Tk, Button
import tkinter.simpledialog

messagebox.showinfo("Info", 
                    ("Diese Demo öffnet eine .DLL Datei. Diese muss von dieser Demo aus erreichbar und ausführbar sein.\n\n"
                     "[Verzeichniswurzel]\n"
                     "- Demo.exe\n"
                     "- ymlib\n"
                     "  - Release\n"
                     "    - YMLib.dll (<-- wird benötigt, sonst kein Start)"))

import demo

# creating a global variable "ymcom"
# this is against good practices and only for demonstration purposes of this simple UI.
import sys
this_module = sys.modules[__name__]
this_module.ymcom = None
this_module.connection_established = False


def ui_connect():
    ip_address = tkinter.simpledialog.askstring(
        "Enter IP Address", "Bitte geben Sie IP Addresse ein, mit der Sie sich verbinden wollen!")
    port = tkinter.simpledialog.askinteger(
        "Enter port", "Bitte geben Sie den Port ein!")
    messagebox.showinfo(
        "Information", "Versuche eine Verbindung aufzubauen mit {}:{}.".format(ip_address, port))
    ymcom = this_module.ymcom
    this_module.ymcom = demo.get_ymcom_connection(ip_address, port, ymcom)
    this_module.connection_established = True


def ui_send_connection():
    if not this_module.connection_established:
        messagebox.showinfo(
            "Information", "Bisher ist noch kein Gerät verbunden. Bitte stellen Sie zuerst eine Verbindung her!")
        ui_connect()

    byte1 = tkinter.simpledialog.askstring(
        "Enter Byte", "Bitte geben Sie das erste Byte an!")
    byte2 = tkinter.simpledialog.askstring(
        "Enter IP Address", "Bitte geben das zweite Byte an!")
    byte3 = tkinter.simpledialog.askstring(
        "Enter IP Address", "Bitte geben das dritte Byte an!")
    byte4 = tkinter.simpledialog.askstring(
        "Enter IP Address", "Bitte geben das vierte Byte an!")

    messagebox.showinfo("Information", "Versuche YMCom.SEND_STATUS_HYBRID32({}, {}, {}, {}) aufzurufen.".format(
        byte1, byte2, byte3, byte4))
    demo.send_status_hybrid(this_module.ymcom, byte1, byte2, byte3, byte4)


def ui_is_open():
    if not this_module.connection_established:
        messagebox.showinfo(
            "Information", "Bisher ist noch kein Gerät verbunden. Bitte stellen Sie zuerst eine Verbindung her!")
        ui_connect()
    is_open = demo.is_open(this_module.ymcom)
    messagebox.showinfo(
        "Information", "YMCom.IsOpen hat den Wert: {}.".format(is_open))


def print_ymcom():
    is_ymcom_instantiated = this_module.ymcom is not None
    messagebox.showinfo(
        "Information", "ymcom ist initialisiert: {}.".format(is_ymcom_instantiated))

def _print_first_connect(*args, **kwargs):
    paramlist = ""
    ymcom = this_module.ymcom
    custom_params_str = ""
    custom_params = {"YMCom.YM_TimeoutStatus": ymcom.YM_TimeoutStatus,
                        "YMCom.YM_Con_DeviceName": ymcom.YM_Con_DeviceName,
                        "YMCom.YM_Parse1": ymcom.YM_Parse1,
                        "YMCom.YM_Parse2": ymcom.YM_Parse2,
                        "YMCom.YM_Parse3": ymcom.YM_Parse3,
                        "YMCom.YM_Parse4": ymcom.YM_Parse4,
                        "YMCom.YM_SecIndex": ymcom.YM_SecIndex,
                        "YMCom.YM_TimeOutChecked": ymcom.YM_TimeOutChecked }
        
    print(custom_params_str)
    messagebox.showinfo("Information", "Event Listener wurde getriggered mit folgenden Parametern: \n{} ".format(custom_params_str))

def ui_register_listener():
    this_module.ymcom.FirstConnect += _print_first_connect

def start_ui():
    window = Tk()
    window.title("Nutzung von Yamutec mit Python")
    window.geometry("400x300")
    window.config(bg="#5ea00e")
    Button(window, text="Test YMCOM.CONNECT", command=ui_connect).pack(pady=(50, 2))
    Button(window, text="Test YMCOM.SEND_STATUS_HYBRID",
           command=ui_send_connection).pack(pady=2)
    Button(window, text="Test YMCOM.IS_OPEN", command=ui_is_open).pack(pady=2)
    Button(window, text="Ist ymcom initialisiert?",
           command=print_ymcom).pack(pady=4)
    window.mainloop()


if __name__ == "__main__":
    this_module.ymcom = this_module.ymcom or demo.get_ymcom()
    ui_register_listener()
    start_ui()
    
